@use 'global';

@mixin tablet {
  @media (min-width: 480px) {
      @content;
  }
}

@mixin small-laptop {
  @media (min-width: 1250px) and (max-height: 760px) {
      @content;
  }
}

@mixin laptop {
  @media (min-width: 1250px) {
      @content;
  }
}

@mixin desktop {
  @media (min-width: 1600px) {
      @content;
  }
}

@mixin heading-1() {
  font-family: 'Ailerons';
  font-size: 2.4rem;
  letter-spacing: -0.2em;
  line-height: 1em;

  @include laptop() {
    font-size: 3rem;
  }

  @include desktop() {
    font-size: 4rem;
  }

  &--small {
    letter-spacing: -0.2em;
    font-size: 1.6rem;

    @include laptop() {
      font-size: 2.4rem;
    }

    @include desktop() {
      font-size: 3rem;
    }
  }
}

@mixin heading-2() {
  font-family: 'Ailerons';
  font-size: 2rem;

  @include laptop() {
    font-size: 3rem;
  }
}

@mixin heading-3() {
  font-family: 'Ailerons';
  font-size: 1.7rem;

  @include laptop() {
    font-size: 2.2rem;
  }
}

@mixin bold-paragraph() {
  font-weight: 500;
}

@mixin radial-gradient($number) {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  z-index: -10;

  @if ($number == 1) {
    background: radial-gradient(circle 100vw at 10vw 10vh, rgba(#FF1FF6, .15), transparent);
  } @else if ($number == 2) {
    background: radial-gradient(circle 100vh at 80vw 0, rgba(#671FFF, .15), transparent);
  } @else if ($number == 3) {
    background: radial-gradient(circle 100vw at 50vw 100vh, rgba(#9C1FFF, .15), transparent);

    @include laptop() {
      background: radial-gradient(circle 100vw at 50vw 150vh, rgba(#9C1FFF, .15), transparent);
    }
  }
}

@mixin glowing($color) {
  box-shadow: 0 0 1rem rgba($color, .2), inset 0 0 1rem rgba($color, .2);
}

@keyframes card-anim {
  0% {
    height: 0;
    padding: 0 16px;
    opacity: 0;
  }
  75% {
    opacity: 1;
  }
  100% {
    height: 100%;
    padding: 16px;
  }
}

@mixin card($self, $color) {
  display: flex;
  padding: 16px;
  flex-direction: column;
  align-items: center;
  border : 1px solid;
  background: linear-gradient(0deg, rgba(#22153C, 0.8) 0%, rgba(#22153C, 0) 70%);
  border-color: $color;
  @include glowing($color);
  animation: card-anim 2s .5s cubic-bezier(.8, 0, .2, 1);
  transform-style: preserve-3d;

  #{$self}__infos {
    color : $color;
    width: 100%;
    display: flex;
    gap: 1rem;
    justify-content: space-between;
    align-items: center;    
    transform-style: preserve-3d;
    transform: translateZ(1rem);
  }

  #{$self}__image {
    width: 10rem;
    padding: 12px;
    transform-style: preserve-3d;
    transform: translateZ(-2rem);

    @include desktop() {
      width: 14rem;
    }
  }

  #{$self}__link {
    padding: 12px 0;
    background-color: rgba(global.$dark, .2);

    @include laptop() {
      background-color: rgba(global.$dark, .3);
    }
  }

  #{$self}__number {
    border: 1px solid;
    border-radius: 100%;
    width: 2rem;
    height: 2rem;
    display: flex;
    align-items: center;
    justify-content: center;
  }

  #{$self}__container {
    position: relative;
    transform-style: preserve-3d;
  }

  #{$self}__caption {
    position: absolute;
    top: 50%;
    left: 50%;
    transform-style: preserve-3d;
    transform: translate(-50%, -50%) translateZ(2rem);
  }

  #{$self}__link {
    border: 1px solid $color;
    border-radius: 30px;
    padding: 15px;
  }

  #{$self}__title {
    color : $color;
    width: 100%;
    padding: 10px;
    font-size: 1rem;
    
    transform-style: preserve-3d;
    transform: translateZ(1rem);
  }

  #{$self}__gauge {
    margin: 10px;
    margin-top: 0px;
    width: 95%;
    height: 10px;
    border: 1px solid $color;
    position: relative;
    transform-style: preserve-3d;
    transform: translateZ(1rem);

    &::before {
      content: '';
      position: absolute;
      top: 0;
      left: 0;
      width: 0;
      height: 100%;
      background-color: $color;
    }

    &.full::before {
      width: 100%;
      transition: .5s cubic-bezier(0, .5, 1, 0);
    }
  }

  @include laptop() {
    #{$self}__link {
      opacity: 0;
      transition: .3s ease-in-out;
    }

    &:hover {
      #{$self}__link {
        opacity: 1;
      }
    }
  }
}